c *** subroutine: calc_sig.for **** date: 13 Sep 2002 ******************
c Calculate spatial domain signal from spherical harmonic coefficients.
c***********************************************************************
      subroutine calc_sig(clm,slm,phi,th,sig_out)
      implicit none
      include 'spharms.inc'
c
      integer i,j,k,l,m
      real*8 clm(0:lmax,0:lmax),slm(0:lmax,0:lmax)
      real*8 phi(phmax),th(thmax),sig_out(phmax,thmax)
      real*8 plm(0:lmax,0:lmax)
      real*8 d_cos(0:lmax,thmax),d_sin(0:lmax,thmax)
c
c--  Calculate fourier coefficients from legendre coefficients  -----c
      do m=1,thmax
         do l=0,lmax
            d_cos(l,m)=0d0
            d_sin(l,m)=0d0
         enddo
      enddo
      do k=1,thmax
         call dpleg(plm,dcos(th(k)))
         do i=0,lmax
            do j=i,lmax
               d_cos(i,k)=d_cos(i,k)+plm(j,i)*clm(j,i)
               d_sin(i,k)=d_sin(i,k)+plm(j,i)*slm(j,i)
            enddo
         enddo
      enddo
c
c--  Final signal recovery from fourier coefficients  ---------------c
      do i=1,thmax   
         do j=1,phmax
            sig_out(j,i)=0d0
         enddo
      enddo
c
      do i=1,thmax   
         do j=1,phmax
            do k=0,lmax
               sig_out(j,i)=sig_out(j,i)
     &              +d_cos(k,i)*dcos(phi(j)*dfloat(k))
     &              +d_sin(k,i)*dsin(phi(j)*dfloat(k))
            enddo
         enddo
      enddo
c
      return
      end
c
