c *** subroutine: dpleg.for **** date: 13 Sep 2002 *********************
c Uses Martin Mohlenkamp's recursion relation; returns plms
c   (geodesy normalization) in plm;  x is cos(co-lat), ptemp
c   is a dummy array of length (0:lmax).
c***********************************************************************
      subroutine dpleg(plm,x_i)
      implicit none
      include 'spharms.inc'
c
      integer l,j,k,mm
      real*8 plm(0:lmax,0:lmax)
      real*8 x_i
      real*8 rsin
      real*8 ptemp(0:lmax)
c
      rsin=dsqrt(1d0-x_i*x_i)

      do mm=0,lmax
         do l=0,lmax
            plm(l,mm)=0d0
         enddo
      enddo
c
c  Initialize recurrence relation
      do mm=0,lmax
         ptemp(0)=1d0/dsqrt(2d0)
c
         do j=1,mm
            ptemp(0)=ptemp(0)*dsqrt(1d0+1d0/2d0/dfloat(j))
         enddo
c
         if((lmax-mm).gt.0)then
            do k=1,lmax-mm
               ptemp(k)=2d0*x_i*ptemp(k-1)
     &              *dsqrt(1d0+(dfloat(mm)-0.5d0)/dfloat(k))
     &              *dsqrt(1d0-(dfloat(mm)-0.5d0)/dfloat(k+2*mm))
               if(k.gt.1)then
                  ptemp(k)=ptemp(k)
     &                 -ptemp(k-2)*dsqrt(1d0+4d0/dfloat(2*k+2*mm-3))
     &                 *dsqrt(1d0-1d0/dfloat(k))
     &                 *dsqrt(1d0-1d0/dfloat(k+2*mm))
               endif
            enddo
         endif
c
c---  Normalization is geodesy convention  ------------------------c
         do l=mm,lmax
            if(mm.eq.0)then
               plm(l,mm)=dsqrt(2d0)*ptemp(l-mm)
            else
               plm(l,mm)=2d0*rsin**mm*ptemp(l-mm)
            endif
         enddo
      enddo
c
      return
      end
c
